"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PlatformServerlessHttp = void 0;
const tslib_1 = require("tslib");
const common_1 = require("@tsed/common");
const serverless_http_1 = tslib_1.__importDefault(require("serverless-http"));
class PlatformServerlessHttp {
    static bootstrap(module, settings) {
        const platform = common_1.PlatformBuilder.create(module, settings);
        const promise = platform.listen();
        platform.handler = () => {
            let handler;
            return async (event, context) => {
                // istanbul ignore else
                if (!handler) {
                    await promise;
                    handler = (0, serverless_http_1.default)(platform.callback(), {
                        request(request) {
                            request.serverless = { event, context };
                        }
                    });
                }
                return handler(event, context);
            };
        };
        return platform;
    }
}
exports.PlatformServerlessHttp = PlatformServerlessHttp;
//# sourceMappingURL=PlatformServerlessHttp.js.map